package handlers

import (
	"net/http"

	// "sort"

	"easydo-echo_win7/models"
	"easydo-echo_win7/services"
	"easydo-echo_win7/utils"

	"easydo-echo_win7/middleware"

	"github.com/jmoiron/sqlx"
	"github.com/labstack/echo-contrib/session"
	"github.com/labstack/echo/v4"
)

func Add_sale_order_to_routes(e *echo.Echo) {
	group := e.Group("/saleOrder")
	group.Use(middleware.AuthMiddleware)
	group.POST("/getPage", saleOrderGetPage)
	group.POST("/save", saleOrderSave)
	group.POST("/update", saleOrderUpdate)
	group.POST("/remove", saleOrderRemove)
}

func saleOrderGetPage(c echo.Context) error {
	var paramMap map[string]interface{}
	if err := c.Bind(&paramMap); err != nil {
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("参数解析失败", err.Error()))
	}
	result, err := services.JdbcClient.GetJdbcPage(paramMap, models.SaleOrder{})
	if err != nil {
		utils.PrintSqlErr(err)
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", err.Error()))
	}
	list := utils.ConvertInterface[[]models.SaleOrder](result.Records)
	if len(list) == 0 {
		list = []models.SaleOrder{}
	}
	for i := range list {
		model := list[i]
		minioList, err := services.JdbcClient.GetMinioFile(model)
		if err != nil {
			utils.PrintSearchFileErr(err)
		}
		model.FileList = &minioList

		detailParam := new(models.SaleOrderDetail)
		detailParam.OrderId = model.ID
		result, err := services.JdbcClient.GetJdbcListByObject(detailParam)
		if err != nil {
			utils.PrintSqlErr(err)
			return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", err.Error()))
		}
		detail_list := utils.ConvertInterface[[]models.SaleOrderDetail](result)

		for j := range detail_list {
			detail := detail_list[j]

			material := new(models.ProductMaterial)
			material.Code = detail.MaterialCode
			err = services.JdbcClient.GetJdbcModel(material)
			if err != nil {
				utils.PrintSqlErr(err)
				return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", err.Error()))
			}

			detail.Material = material

			detail_list[j] = detail
		}
		model.ChildrenList = &detail_list

		if model.ManagerId != nil && *model.ManagerId != 0 {
			manager := new(models.SysUser)
			manager.ID = model.ManagerId
			err = services.JdbcClient.GetJdbcModelById(manager)
			if err != nil {
				utils.PrintSqlErr(err)
				return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", err.Error()))
			}
			model.ManagerName = manager.NickName
		}
		if model.CustomerId != nil && *model.CustomerId != "" {
			customer := new(models.Customer)
			customer.ID = model.CustomerId
			err = services.JdbcClient.GetJdbcModelById(customer)
			if err != nil {
				utils.PrintSqlErr(err)
				return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", err.Error()))
			}
			model.CustomerName = customer.Name
		}

		list[i] = model
	}
	result.Records = list
	return c.JSON(http.StatusOK, result)
}

func saleOrderSave(c echo.Context) error {
	tx, _ := services.MYSQL_DB.Beginx()

	order := new(models.SaleOrder)
	if err := c.Bind(order); err != nil {
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("参数解析失败", err.Error()))
	}
	sess, _ := session.Get("auth_session", c)
	err_msg := saleOrder_generateCode(order, tx)
	if err_msg != "" {
		tx.Rollback()
		return c.JSON(http.StatusBadRequest, utils.ErrorResponse(err_msg, ""))
	}
	user_id, ok := sess.Values["user_id"].(int64)
	if !ok {
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("用户请先登录", ""))
	}
	order.CreateId = &user_id
	status := models.Sale_Order_Status_Pending
	order.Status = &status
	services.JdbcClient.JdbcInsert(order, tx)

	detail_list := *order.ChildrenList
	for _, detail := range detail_list {
		detail.OrderId = order.ID
		err := services.JdbcClient.JdbcInsert(&detail, tx)
		if err != nil {
			utils.PrintSqlErr(err)
			tx.Rollback()
			return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", ""))
		}
	}

	if order.FileList == nil {
		tx.Commit()
		return c.JSON(http.StatusOK, order)
	}
	fileList := *order.FileList
	for _, file := range fileList {
		file.RefId = order.ID
		refType := models.File_Ref_Type_Sale_Order
		file.RefType = &refType

		err := services.JdbcClient.JdbcInsert(&file, tx)
		if err != nil {
			utils.PrintSqlErr(err)
			tx.Rollback()
			return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", ""))
		}
	}

	tx.Commit()
	return c.JSON(http.StatusOK, order)

}

func saleOrderUpdate(c echo.Context) error {
	tx, _ := services.MYSQL_DB.Beginx()

	order := new(models.SaleOrder)
	if err := c.Bind(order); err != nil {
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("参数解析失败", err.Error()))
	}
	sess, _ := session.Get("auth_session", c)
	user_id, ok := sess.Values["user_id"].(int64)
	if !ok {
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("用户请先登录", ""))
	}
	order.UpdateId = &user_id
	err := services.JdbcClient.JdbcUpdateById(order, tx)
	if err != nil {
		utils.PrintSqlErr(err)
		tx.Rollback()
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", ""))
	}

	order_detial := new(models.SaleOrderDetail)
	order_detial.OrderId = order.ID
	err = services.JdbcClient.JdbcRemove(order_detial, tx)
	if err != nil {
		utils.PrintSqlErr(err)
		tx.Rollback()
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", ""))
	}

	detail_list := *order.ChildrenList
	for _, detail := range detail_list {
		detail.OrderId = order.ID
		err := services.JdbcClient.JdbcInsert(&detail, tx)
		if err != nil {
			utils.PrintSqlErr(err)
			tx.Rollback()
			return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", ""))
		}
	}

	if order.FileList == nil {
		tx.Commit()
		return c.JSON(http.StatusOK, order)
	}

	fileList := *order.FileList
	for _, file := range fileList {
		file.RefId = order.ID
		refType := models.File_Ref_Type_Sale_Order
		file.RefType = &refType

		err := services.JdbcClient.JdbcInsert(&file, tx)
		if err != nil {
			utils.PrintSqlErr(err)
			tx.Rollback()
			return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", ""))
		}
	}

	tx.Commit()
	return c.JSON(http.StatusOK, order)
}

func saleOrderRemove(c echo.Context) error {
	tx, _ := services.MYSQL_DB.Beginx()

	order := new(models.SaleOrder)
	if err := c.Bind(order); err != nil {
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("参数解析失败", err.Error()))
	}

	err := services.JdbcClient.JdbcRemoveById(order, tx)
	if err != nil {
		utils.PrintSqlErr(err)
		tx.Rollback()
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", ""))
	}

	minio_file := new(models.MinioFile)
	minio_file.RefId = order.ID
	refType := models.File_Ref_Type_Sale_Order
	minio_file.RefType = &refType
	err = services.JdbcClient.JdbcRemove(minio_file, tx)
	if err != nil {
		utils.PrintSqlErr(err)
		tx.Rollback()
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", ""))
	}

	order_detial := new(models.SaleOrderDetail)
	order_detial.OrderId = order.ID
	err = services.JdbcClient.JdbcRemove(order_detial, tx)
	if err != nil {
		utils.PrintSqlErr(err)
		tx.Rollback()
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", ""))
	}

	tx.Commit()
	return c.JSON(http.StatusOK, order)
}

func saleOrder_generateCode(model *models.SaleOrder, tx *sqlx.Tx) string {
	sync := new(models.Synchronized)
	sync.Sync.Lock()
	defer sync.Sync.Unlock()

	if model.Code != nil && len(*model.Code) > 0 {
		modelParam := new(models.SaleOrder)
		modelParam.Code = model.Code
		modelParam.TenantId = model.TenantId
		count, err := services.JdbcClient.GetJdbcCount(modelParam, tx)
		if err != nil {
			utils.PrintSqlErr(err)
			return "SQL执行失败"
		}
		if count > 0 {
			return "编号已存在，请重新填写"
		}
	} else {
		for {
			code, err := services.GetFlowNo(models.Flow_No_Type_Sale_Order, *model.TenantId, tx)
			if err != nil {
				return "自动生成编码失败"
			}
			modelParam := new(models.SaleOrder)
			modelParam.Code = &code
			modelParam.TenantId = model.TenantId
			count, err := services.JdbcClient.GetJdbcCount(modelParam, tx)
			if err != nil {
				utils.PrintSqlErr(err)
				return "SQL执行失败"
			}
			if count == 0 {
				model.Code = &code
				break
			}
		}

	}
	return ""
}
